Subject: Re: [PATCH] powerpc: i2c-mpc: make speed registers configurable via FDT

From: Wolfgang Grandegger <[email-masked]>
Date: Thu, 31 Jul 2008 23:14:40 +0200

Jon Smirl wrote:
> On 7/31/08, Timur Tabi <[email-masked]> wrote:
>> Jon Smirl wrote:
>>
>>  > Isn't there a single global divider that generates all the i2c source
>>  > clocks? You don't want to copy a global value into each i2c node.
>>
>>
>> Why not?  There are only two I2C devices, and it's theoretically possible for
>>  them to have different input clock frequencies.   Keeping it in the I2C node
>>  allows the I2C driver to reference a property directly in the node that its probing.
> 
> But that's the same as saying we should copy the system clock
> frequency into all of the PSC nodes because we might implement
> hardware where they aren't all clocked off from the same input clock
> source.
> 
>>  > Aren't we talking about the /2 or /3 or /1 divider that appears to be
>>  > randomly implemented on various members of the mpc8xxx family?
> 
> I don't this these dividers or clocks need to be exposed at all if
> you'd just put that ugly code snippet into your platform driver.

U-Boot does not (yet) use the FDT and it has therefore to use that ugly 
code to derive the I2C input clock frequency. I think its completely 
legal to put that hardware specific information into the FDT and get rid 
of such code.

Wolfgang.